#include "gst-test.h"
PlayerInstance::PlayerInstance(char *path)
    : m_sPath (path)
{
    ETG_TRACE_USR4 (("PlayerInstance: Inside"));

	m_goteos =0;
    //moveToThread(this);
inited = 0;


    ETG_TRACE_USR4 (("PlayerInstance: Initializing member variables"));

    //Initialize members to sane values

    ETG_TRACE_USR4 (("PlayerInstance: Creating Manager"));


    m_ccAudioSinkDevicePath   = NULL;
    m_ccAudioSrcDevicePath    = NULL;
    m_pEncodingType           = NULL;
    m_bStatus                 = false;

    m_pAudioSink              = NULL;
    m_pAudioConvert           = NULL;
    m_pVolume                 = NULL;
    //Disintegrate Hotfix #0396 --     m_IsVideoFile             = false;
    //Disintegrate Hotfix #0396 --     m_Video_PlaypointPosition = 0;
    m_pVideoSink              = NULL;

    m_bAudioStreamExist       = false;
    m_bVideoStreamExist       = false;
    m_pAudioPad               = NULL;
    m_pVideoPad               = NULL;

    m_pGenre                  = NULL;
    m_pAlbum                  = NULL;
    m_pArtist                 = NULL;
    m_pTitle                  = NULL;
    m_pAudioCodec             = NULL;
    m_pSourceName             = NULL;
    m_iBitrate                = 0;

    m_bMetaDataChanged        = false;

    m_iDuration               = 0;
    m_iCurrentTime            = 0;
    m_iTimerID                = -1;
    m_pBtTimerID              = -1;
    m_eStateBeforeTransition  = -1;

    m_iTimerFRID              = -1;

    m_pPipeline               = NULL;
    m_pAudioQueue             = NULL;
    m_pVideoQueue             = NULL;

    m_pSource                 = NULL;
    m_pDecodeBin              = NULL;

    m_iSourceType             = 0;

    m_bPlayerInitialized      = false;
    m_bEventThreadRunning     = false;
    m_bSeeking                = false;
    m_bFindFRstatus           = false;
    m_bfirstTagInfo           = false;
    m_bSentBufferingMsg       = false;

    m_iPipeFileDesc           = -1;
    m_bExplicitStop           = false;
    m_isAlive                 = false;




    ETG_TRACE_USR4 (("PlayerInstance: Leaving"));
}


void PlayerInstance::PadAddedCallback(GstElement *f_pUriDecodebin, GstPad *f_pPad, gpointer f_pUserData)
{
    GstCaps *l_pCaps;
    PlayerInstance *l_pPlayerInstance = (PlayerInstance *)f_pUserData;

    (void)f_pUriDecodebin;
  GstPad *audiopad;
printf("=================in NewPadAddedCallback\n");
  /* only link once */
  audiopad = gst_element_get_static_pad (l_pPlayerInstance->m_audio, "sink");
  
  if (GST_PAD_IS_LINKED (audiopad)) {
	  ETG_TRACE_USR4(("NewPadAddedCallback: GST_PAD_IS_LINKED\n\n"));
    g_object_unref (audiopad);
    return;
  }
  
    ETG_TRACE_USR4(("NewPadAddedCallback: Got New Pad from Decodebin\n"));
    l_pCaps = gst_pad_query_caps (f_pPad,NULL);

    if(l_pCaps)
    {
        GstStructure *l_pStructure;
        gchar *l_pName = NULL;
        l_pStructure = gst_caps_get_structure (l_pCaps, 0);
        l_pName = const_cast<gchar*>(gst_structure_get_name (l_pStructure));

        if(!strstr(l_pName, "audio"))
        {
            ETG_TRACE_USR4(("!!!!!!NewPadAddedCallback: NOT GOT Audio Pad\n\n"));

                l_pPlayerInstance->m_pAudioPad = f_pPad;
                l_pPlayerInstance->m_bAudioStreamExist = true;
                gst_caps_unref (l_pCaps);
                g_object_unref (audiopad);
                return;
   
        }
            ETG_TRACE_USR4(("!!!!!!NewPadAddedCallback:  GOT Audio Pad\n\n"));

  gst_caps_unref (l_pCaps);

  /* link'n'play */
  gst_pad_link (f_pPad, audiopad);

  g_object_unref (audiopad);
  gst_caps_unref (l_pCaps);
    }
}


PlayerInstance::~PlayerInstance()
{
    ETG_TRACE_USR4 (("~PlayerInstance: Inside"));


    if(m_ccAudioSinkDevicePath)
    {
        ETG_TRACE_USR4 (("~PlayerInstance: Freeing AudioSink Device Path"));
        free(m_ccAudioSinkDevicePath);
        m_ccAudioSinkDevicePath = NULL;
    }
    if(m_ccAudioSrcDevicePath)
    {
        ETG_TRACE_USR4 (("~PlayerInstance: Freeing AudioSrc Device Path"));
        free(m_ccAudioSrcDevicePath);
        m_ccAudioSrcDevicePath = NULL;
    }

    if(m_pGenre)
    {
        ETG_TRACE_USR4 (("~PlayerInstance: Freeing Genre"));
        free(m_pGenre);
        m_pGenre = NULL;
    }
    if(m_pAlbum)
    {
        ETG_TRACE_USR4 (("~PlayerInstance: Freeing Album"));
        free(m_pAlbum);
        m_pAlbum = NULL;
    }
    if(m_pArtist)
    {
        ETG_TRACE_USR4 (("~PlayerInstance: Freeing Artist"));
        free(m_pArtist);
        m_pArtist = NULL;
    }
    if(m_pTitle)
    {
        ETG_TRACE_USR4 (("~PlayerInstance: Freeing Title"));
        free(m_pTitle);
        m_pTitle = NULL;
    }
    if(m_pAudioCodec)
    {
        ETG_TRACE_USR4 (("~PlayerInstance: Freeing Codec"));
        free(m_pAudioCodec);
        m_pAudioCodec = NULL;
    }
    if(m_pSourceName)
    {
        ETG_TRACE_USR4 (("~PlayerInstance: Freeing SourceName"));
        free(m_pSourceName);
        m_pSourceName = NULL;
    }

    m_iBitrate = 0;

    if(m_pPipeline)
    {
        g_source_remove_by_user_data(m_pPipeline);
        gst_object_unref(m_pPipeline);
        m_pPipeline = NULL;
    }
    if(m_pAudioQueue)
    {
        gst_object_unref(m_pAudioQueue);
        m_pAudioQueue = NULL;
    }
    if(m_pVideoQueue)
    {
        gst_object_unref(m_pVideoQueue);
        m_pVideoQueue = NULL;
    }


    ETG_TRACE_USR4 (("~PlayerInstance: Leaving"));
}

void PlayerInstance::UnKnownTypeCallback (GstElement *f_pDecodebin, GstPad *f_pPad, GstCaps *f_pCaps, gpointer f_pUserData)
{
    ETG_TRACE_USR4(("UnKnownTypeCallback: Unknown Pad from Decodebin"));
    (void)f_pDecodebin;
    (void)f_pPad;
    (void)f_pCaps;
    (void)f_pUserData;
}

void PlayerInstance::NoMorePadsCallback(GstElement * f_pDecodebin, gpointer f_pUserData)
{
    PlayerInstance *l_pPlayerInstance = (PlayerInstance *)f_pUserData;
    (void) f_pDecodebin;
    /*if(l_pPlayerInstance->m_bAudioStreamExist == true || l_pPlayerInstance->m_bVideoStreamExist == true)
    {
         gst_element_set_state(l_pPlayerInstance->m_pPipeline, GST_STATE_PAUSED);
    }*/
printf("=============NoMorePadsCallback=====================");

				gst_bin_add (GST_BIN (l_pPlayerInstance->m_pPipeline), l_pPlayerInstance->m_audio);
				return;
if(l_pPlayerInstance->inited)
return;
    LOG2("NoMorePadsCallback: No More Pads from Decodebin");

	if(l_pPlayerInstance->m_bAudioStreamExist == true)
    {
        ETG_TRACE_USR4(("NoMorePadsCallback: Only Audio stream Exist"));
        GstPad *l_pAudioSinkPad = NULL;
        gst_element_set_state(l_pPlayerInstance->m_pAudioConvert, GST_STATE_PLAYING);
        gst_element_set_state(l_pPlayerInstance->m_pAudioSink, GST_STATE_PLAYING);
        gst_element_set_state(l_pPlayerInstance->m_pVolume, GST_STATE_PLAYING);
        //gst_element_set_state(l_pPlayerInstance->m_pAudioConvert, GST_STATE_PAUSED);//Added for mySPINup Audio pop noise issue
        //Disintegrate Hotfix #0396 -- gst_element_set_state(l_pPlayerInstance->m_pAudioConvert, l_pPlayerInstance->m_gstPipelineStateSet);

        //Disintegrate Hotfix #0396 -- gst_element_set_state(l_pPlayerInstance->m_pAudioResample, l_pPlayerInstance->m_gstPipelineStateSet);
        //Disintegrate Hotfix #0396 -- gst_element_set_state(l_pPlayerInstance->m_pAudioConvertCapsFilter, l_pPlayerInstance->m_gstPipelineStateSet);

        //gst_element_set_state(l_pPlayerInstance->m_pAudioSink, GST_STATE_PAUSED);//Added for mySPINup Audio pop noise issue
        //Disintegrate Hotfix #0396 -- gst_element_set_state(l_pPlayerInstance->m_pAudioSink, l_pPlayerInstance->m_gstPipelineStateSet);

        //gst_element_set_state(l_pPlayerInstance->m_pVolume, GST_STATE_PAUSED);//Added for mySPINup Audio pop noise issue
        //Disintegrate Hotfix #0396 -- gst_element_set_state(l_pPlayerInstance->m_pVolume, l_pPlayerInstance->m_gstPipelineStateSet);
        LOG2("NoMorePadsCallback: Adding AudioConvert and Audio Sink to Pipeline");


        gst_bin_add_many(GST_BIN (l_pPlayerInstance->m_pPipeline),
                         l_pPlayerInstance->m_pAudioConvert,
                         l_pPlayerInstance->m_pVolume,
                         l_pPlayerInstance->m_pAudioSink,
                         (const char*)NULL);
        LOG2("NoMorePadsCallback: Linking Audio Queue, AudioConvert and Audio Sink");
        gst_element_link_many(l_pPlayerInstance->m_pAudioConvert,
                              l_pPlayerInstance->m_pVolume,
                              l_pPlayerInstance->m_pAudioSink,
                              (const char*)NULL);


        LOG2("NoMorePadsCallback: Getting sink pad AudioConvert Sink Pad");
        l_pAudioSinkPad = gst_element_get_static_pad (l_pPlayerInstance->m_pAudioConvert, "sink");
        LOG2("Linking Audio Pad with and AudioConvertSinkPad");
        if(l_pAudioSinkPad && (gst_pad_link(l_pPlayerInstance->m_pAudioPad, l_pAudioSinkPad)== GST_PAD_LINK_OK))
        {
			l_pPlayerInstance->inited = 1;
            ETG_TRACE_USR4(("NoMorePadsCallback: Linking Audio Pad with and AudioSink sink pad successful"));
        }
        else
        {
            ETG_TRACE_USR4(("NoMorePadsCallback: ERROR: Linking Audio Pad with and AudioSink sink pad Failed"));
        }
    }


}

int PlayerInstance::CreateFilePlaybackElements(char *f_ccMediaSrcPath)
{
    ETG_TRACE_USR4 (("CreateFilePlaybackElements: Inside"));

    int l_iError = GSTPLAYER_SUCCESS;

    ETG_TRACE_USR4 (("CreateFilePlaybackElements: Creating AudioElements"));
    l_iError = CreateAudioElements();
    if(l_iError == GSTPLAYER_SUCCESS)
    {

        if(l_iError == GSTPLAYER_SUCCESS)
        {
            ETG_TRACE_USR4 (("CreateFilePlaybackElements: Creating filesrc"));
            m_pSource = gst_element_factory_make("filesrc", "source");

            ETG_TRACE_USR4 (("CreateFilePlaybackElements: Creating Decodebin2"));
            m_pDecodeBin = gst_element_factory_make("decodebin", "decoder");

            if(!m_pSource || !m_pDecodeBin)
            {
                ETG_TRACE_ERR (("CreateFilePlaybackElements: [ERROR] Creation of Source or decodebin failed"));

                l_iError = GSTPLAYER_ERROR;
            }
            else
            {
                ETG_TRACE_USR4 (("CreateFilePlaybackElements: Setting location on filesrc"));
                g_object_set ((GObject*)m_pSource, "location", f_ccMediaSrcPath, (const char*)NULL);
                g_object_set((GObject*)m_pAudioSink, "sync", true, NULL);

				g_signal_connect (m_pDecodeBin, "pad-added", G_CALLBACK (&PadAddedCallback), this); //Added by sdd1cob
                //g_signal_connect (m_pDecodeBin, "unknown-type", G_CALLBACK (&UnKnownTypeCallback), this);
                //g_signal_connect (m_pDecodeBin, "no-more-pads", G_CALLBACK (&NoMorePadsCallback), this);

                ETG_TRACE_USR4 (("CreateFilePlaybackElements: Adding source and decodebin to pipeline"));
                gst_bin_add(GST_BIN (m_pPipeline),
                                 m_pDecodeBin);

                ETG_TRACE_USR4 (("CreateFilePlaybackElements: Linking source and decodebin"));
                //gst_element_link(m_pSource,m_pDecodeBin);
                
                #if 0
                m_audio = gst_bin_new ("audiobin");
                GstPad *audiopad;
                audiopad = gst_element_get_static_pad (m_pAudioConvert, "sink");
				gst_bin_add_many (GST_BIN (m_audio), m_pAudioConvert, m_pVolume, m_pAudioSink, NULL);
				gst_element_link (m_pAudioConvert, m_pVolume);
				gst_element_link (m_pVolume, m_pAudioSink);
				gst_element_add_pad (m_audio, gst_ghost_pad_new ("sink", audiopad));
				gst_object_unref (audiopad);
				gst_bin_add (GST_BIN (m_pPipeline), m_audio);
				l_iError = GSTPLAYER_SUCCESS;
				#endif
				gst_bin_add (GST_BIN (m_pPipeline), m_audio);
				gst_bin_add(GST_BIN (m_pPipeline),m_pSource);
						printf("CreateFilePlaybackElements end------------------\n");
            }

        }

    }

    ETG_TRACE_USR4 (("!!!!!CreateFilePlaybackElements: Leaving\n\n!!!!"));

    return l_iError;
}

int PlayerInstance::CreateAudioElements()
{
    ETG_TRACE_USR4 (("CreateAudioElements: Inside"));

    int l_iError = GSTPLAYER_SUCCESS;
    ETG_TRACE_USR4 (("CreateAudioElements: Creating Alsa Sink"));
    m_pAudioSink = gst_element_factory_make("alsasink", "sink");

    ETG_TRACE_USR4 (("CreateAudioElements: Creating AudioConvert"));
    m_pAudioConvert = gst_element_factory_make("audioconvert", "aconv");

    ETG_TRACE_USR4 (("CreateAudioElements: Creating Volume element"));
    m_pVolume = gst_element_factory_make("volume", "volume");

    if(!m_pAudioSink && !m_pAudioConvert &&  !m_pVolume)
    {
        ETG_TRACE_ERR (("CreateAudioElements: [ERROR] Creation of AudioElements Failed"));

        l_iError = GSTPLAYER_ERROR;

    }
    else
    {
        if(m_ccAudioSinkDevicePath)
        {
            ETG_TRACE_USR4 (("CreateAudioElements: Setting Device path on AudioSink = %s", m_ccAudioSinkDevicePath));
            g_object_set((GObject*)m_pAudioSink, "device", m_ccAudioSinkDevicePath, NULL);
        }
    }

    ETG_TRACE_USR4 (("======================CreateAudioElements: audiobin"));
                m_audio = gst_bin_new ("audiobin");
                GstPad *audiopad;
                audiopad = gst_element_get_static_pad (m_pAudioConvert, "sink");
				gst_bin_add_many (GST_BIN (m_audio), m_pAudioConvert, m_pVolume, m_pAudioSink, NULL);
				gst_element_link (m_pAudioConvert, m_pVolume);
				gst_element_link (m_pVolume, m_pAudioSink);
				gst_element_add_pad (m_audio, gst_ghost_pad_new ("sink", audiopad));
				gst_object_unref (audiopad);
    return l_iError;
}

bool PlayerInstance::CheckIfFileExists ( char* f_ccFileToplay)
{
    ETG_TRACE_USR4 (("CheckIfFileExists: Inside"));

    bool l_bFileExists = false ;
	int fd=open ( f_ccFileToplay, O_RDONLY );
    if ( fd  > 0)
    {
        l_bFileExists = true;
    }
    else
    {
        ETG_TRACE_ERR (("CheckIfFileExists: [ERROR] File doesn't exists."));


        l_bFileExists = false;
    }

    ETG_TRACE_USR4 (("CheckIfFileExists: Leaving"));
close(fd);
    return l_bFileExists;
}

void PlayerInstance::DestroyPipeline()
{
    ETG_TRACE_USR4 (("DestroyPipeline: Inside"));

#if 1
            if(m_pAudioSink)
            {
				
                gst_object_unref(GST_OBJECT(m_pAudioSink));
                m_pAudioSink = NULL;
            }
            if(m_pAudioConvert)
            {
				
                gst_object_unref(GST_OBJECT(m_pAudioConvert));
                m_pAudioConvert = NULL;
            }


            if(m_pAudioPad)
            {
                gst_object_unref(m_pAudioPad);
                m_pAudioPad = NULL;
            }
           if(m_pVolume)
            {
				
                gst_object_unref(GST_OBJECT(m_pVolume));
                m_pVolume = NULL;
            }
            if(m_pAudioQueue)
            {
                ETG_TRACE_USR4(("Freeing Audio Queue"));
                
                gst_object_unref(GST_OBJECT(m_pAudioQueue));
                m_pAudioQueue = NULL;
            }
                if(m_pSource)
                {
                    ETG_TRACE_USR4 (("CreateFilePlaybackElements: Freeing Source"));
                    gst_object_unref(m_pSource);
                    m_pSource = NULL;
                }
                if(m_pDecodeBin)
                {
					
                    ETG_TRACE_USR4 (("CreateFilePlaybackElements: Freeing Decodebin"));
                    gst_object_unref(GST_OBJECT(m_pDecodeBin));
                    m_pDecodeBin = NULL;
                }
                if(m_pBus)
                {
                    gst_object_unref(m_pBus);
                    m_pBus = NULL;
                }
inited=0;
#endif

    if(m_pPipeline)
    {
        g_source_remove_by_user_data(m_pPipeline);

        ETG_TRACE_USR4 (("DestroyPipeline: Unreferncing pipeline"));
        gst_object_unref(GST_OBJECT(m_pPipeline));
    }


    m_pPipeline         = NULL;

    ETG_TRACE_USR4 (("DestroyPipeline: Leaving"));
}


void PlayerInstance::ToStoppedState(GstElement *e)
{
    ETG_TRACE_USR4 (("ToStoppedState: Inside"));

    GstStateChangeReturn l_gstStateChange = GST_STATE_CHANGE_SUCCESS;
    GstState l_gstState;
    GstState l_gstPendingState;

    
    {
        gst_element_set_state(e, GST_STATE_NULL);
        
        //Disintegrate Hotfix #0396 --         m_gstPipelineStateSet = GST_STATE_NULL;
        l_gstStateChange = gst_element_set_state(e, GST_STATE_NULL);
        if(l_gstStateChange == GST_STATE_CHANGE_FAILURE)
        {
            ETG_TRACE_ERR (("ToStoppedState: [ERROR] Setting Pipeline to NULL state Failed"));
        }
        else
        {
            ETG_TRACE_USR4 (("ToStoppedState: Pipeline changing state asynchronously"));
            do
            {
                int l_iMilliSecond = 1000;
                //5 seconds in nanoseconds
                GstClockTime l_gstTimeOut = (GstClockTime)(10) * l_iMilliSecond * l_iMilliSecond * l_iMilliSecond;
                l_gstStateChange = gst_element_get_state(e,
                                                         &l_gstState,
                                                         &l_gstPendingState,
                                                         l_gstTimeOut);
            }while(l_gstState != GST_STATE_NULL);
        }

    }
    gst_object_unref(e);
    e=NULL;
    ETG_TRACE_USR4 (("\ToStoppedState: Leaving\n"));
}


void PlayerInstance::SetPipelineToStoppedState()
{
    ETG_TRACE_USR4 (("SetPipelineToStoppedState: Inside"));

    GstStateChangeReturn l_gstStateChange = GST_STATE_CHANGE_SUCCESS;
    GstState l_gstState;
    GstState l_gstPendingState;
 /*
ToStoppedState(m_pAudioConvert);
ToStoppedState(m_pAudioSink);
ToStoppedState(m_pVolume);

ToStoppedState(m_pAudioQueue);

ToStoppedState(m_pSource);
ToStoppedState(m_pDecodeBin);

GstPad *l_pAudioSinkPad = NULL;
gst_element_unlink(m_pSource,m_pDecodeBin);
                gst_bin_remove_many(GST_BIN (m_pPipeline),
                                 m_pSource,
                                 m_pDecodeBin,
                                 (const char*)NULL);
                                 
l_pAudioSinkPad = gst_element_get_static_pad (m_pAudioConvert, "sink");
if(l_pAudioSinkPad) 
gst_pad_unlink(m_pAudioPad, l_pAudioSinkPad);
*/

    if(m_pPipeline)
    {
        gst_element_set_state(m_pPipeline, GST_STATE_NULL);
        
        ETG_TRACE_USR4 (("SetPipelineToStoppedState: Pipeline in playing/Paused state. Stopping by Setting to NULL state"));
        l_gstStateChange = gst_element_set_state(m_pPipeline, GST_STATE_NULL);
        if(l_gstStateChange == GST_STATE_CHANGE_FAILURE)
        {
            ETG_TRACE_ERR (("SetPipelineToStoppedState: [ERROR] Setting Pipeline to NULL state Failed"));
        }
        else
        {
            ETG_TRACE_USR4 (("SetPipelineToStoppedState: Pipeline changing state asynchronously"));
            do
            {
                int l_iMilliSecond = 1000;
                //5 seconds in nanoseconds
                GstClockTime l_gstTimeOut = (GstClockTime)(10) * l_iMilliSecond * l_iMilliSecond * l_iMilliSecond;
                ETG_TRACE_USR4 (("SetPipelineToStoppedState: Waiting infinitely for complete state transition by Getting state"));
                l_gstStateChange = gst_element_get_state(m_pPipeline,
                                                         &l_gstState,
                                                         NULL,
                                                         l_gstTimeOut);
            }while(l_gstState != GST_STATE_NULL);
        }

    }
    sleep(2);
 gst_bin_remove (GST_BIN (m_pPipeline), m_audio);
 gst_bin_add_many (GST_BIN (m_audio), m_pAudioConvert, m_pVolume, m_pAudioSink, NULL);

gst_bin_remove(GST_BIN (m_pPipeline), m_pDecodeBin);
  
gst_bin_remove(GST_BIN (m_pPipeline), m_pSource);

    gst_object_unref(GST_OBJECT(m_pPipeline));
    m_pPipeline=NULL;
//DestroyPipeline();
    ETG_TRACE_USR4 (("\nSetPipelineToStoppedState: Leaving\n"));
}


int PlayerInstance::CreatePipeline()
{
    ETG_TRACE_USR4 (("CreatePipeline: Inside"));

    int l_iError = GSTPLAYER_SUCCESS;
    int l_iCount=0;

    if(m_pPipeline)
    {
        ETG_TRACE_USR4 (("CreatePipeline: Setting Pipeline to Stopped state"));
        SetPipelineToStoppedState();
        //DestroyPipeline();
    }

    ETG_TRACE_USR4 (("CreatePipeline: Creating Pipeline"));
    m_pPipeline = gst_pipeline_new (NULL);

    ETG_TRACE_USR4 (("CreatePipeline: creating AudioQueue"));
    m_pAudioQueue = gst_element_factory_make("queue", NULL);
    
    if(!m_pPipeline || !m_pAudioQueue)
    {
        ETG_TRACE_ERR (("CreatePipeline: [ERROR] Creation of Pipeline Elements Failed"));
        l_iError = GSTPLAYER_ERROR;

    }

    if(l_iError == GSTPLAYER_SUCCESS)
    {
        ETG_TRACE_USR4 (("CreatePipeline: Creating Bus for callback messages"));
        m_pBus = gst_pipeline_get_bus (GST_PIPELINE (m_pPipeline));

        GSource* l_pSource = gst_bus_create_watch (m_pBus);
        if (NULL == l_pSource)
        {
            ETG_TRACE_FATAL (("CreatePipeline: Unable to create GSource for m_pBus watch"));
        }
        else
        {
            ETG_TRACE_USR4 (("CreatePipeline: Created GSource"));
            //m_uiBusWatchId =gst_bus_add_watch(m_pBus, (GSourceFunc) MessageLoop, g_main_loop);
            g_source_set_callback (l_pSource, (GSourceFunc) MessageLoop, this, NULL);
            m_uiBusWatchId = g_source_attach (l_pSource, g_main_context_default());

            printf ("CreatePipeline: Attached GSource. Id %d",(int)m_uiBusWatchId);
            g_source_unref (l_pSource);
        }
        gst_object_unref (m_pBus);
    }
    if(m_pGenre)
    {
        ETG_TRACE_USR4 (("CreatePipeline: Freeing previous Genre\n"));
        free(m_pGenre);
        m_pGenre = NULL;
    }
    if(m_pAlbum)
    {
        ETG_TRACE_USR4 (("CreatePipeline: Freeing previous Album\n"));
        free(m_pAlbum);
        m_pAlbum = NULL;
    }
    if(m_pArtist)
    {
        ETG_TRACE_USR4 (("CreatePipeline: Freeing previous Artist\n"));
        free(m_pArtist);
        m_pArtist = NULL;
    }
    if(m_pTitle)
    {
        ETG_TRACE_USR4 (("CreatePipeline: Freeing previous Title\n"));
        free(m_pTitle);
        m_pTitle = NULL;
    }
    if(m_pAudioCodec)
    {
        ETG_TRACE_USR4 (("CreatePipeline: Freeing Codec\n"));
        free(m_pAudioCodec);
        m_pAudioCodec = NULL;
    }
    if(m_pSourceName)
    {
        ETG_TRACE_USR4 (("CreatePipeline: Freeing SourceName\n"));
        free(m_pSourceName);
        m_pSourceName = NULL;
    }

    m_iBitrate = 0;

    ETG_TRACE_USR4 (("CreatePipeline: Uninitializing metaDataChange indicator\n"));
    m_bMetaDataChanged = false;

    ETG_TRACE_USR4 (("CreatePipeline: Leaving\n"));

    return l_iError;
}


int PlayerInstance::SetMediaSource(char *f_ccMediaSrcPath)
{
    ETG_TRACE_USR4 (("SetMediaSource: Inside\n"));
#if 0
	if(m_bPlayerInitialized) 
	{
  GstPad *audiopad;
  GstPad *peerpad;
   printf("========%d\n", __LINE__);
  gst_element_set_state (m_pPipeline, GST_STATE_READY );
 // audiopad = gst_element_get_static_pad (m_pAudioConvert, "sink");
  //peerpad = gst_pad_get_peer (audiopad);
 // if(peerpad)
 // printf("========got peerpad\n");
 // gst_pad_unlink (peerpad, audiopad);
 printf("========%d\n", __LINE__);
 //gst_object_ref(m_audio);
 //gst_bin_remove (GST_BIN (m_pPipeline), m_audio);
 
  printf("========%d\n", __LINE__);
 // gst_object_ref(m_pDecodeBin); 
//gst_bin_remove(GST_BIN (m_pPipeline), m_pDecodeBin);

//  gst_object_ref(m_pSource);
gst_element_set_state (m_pSource, GST_STATE_NULL);   
if(gst_bin_remove(GST_BIN (m_pPipeline), m_pSource)==false)
printf("fail========%d\n", __LINE__);
sleep(5);

m_pSource = gst_element_factory_make("filesrc", NULL);
g_object_set ((GObject*)m_pSource, "location", f_ccMediaSrcPath, (const char*)NULL);
 //   gst_element_unlink (m_pSource, m_pDecodeBin);
 //   gst_element_set_state (m_pSource, GST_STATE_NULL);
  //  gst_element_set_state (m_pDecodeBin, GST_STATE_NULL);
  //  gst_util_set_object_arg (G_OBJECT (m_pSource),"location",f_ccMediaSrcPath);
  //  g_signal_connect (m_pDecodeBin, "pad-added", G_CALLBACK (&PadAddedCallback), this); //Added by sdd1cob
 //g_signal_connect (m_pDecodeBin, "no-more-pads", G_CALLBACK (&NoMorePadsCallback), this);
 printf("========%d\n", __LINE__);

gst_bin_add(GST_BIN (m_pPipeline), m_pSource);
//gst_bin_add(GST_BIN (m_pPipeline), m_pDecodeBin);

//gst_bin_add (GST_BIN (m_pPipeline), m_audio);
GstPad *srcpad=gst_element_get_static_pad (m_pSource, "src");;
audiopad=gst_element_get_static_pad (m_pDecodeBin, "sink");
gst_element_sync_state_with_parent (m_pDecodeBin);
gst_element_sync_state_with_parent (m_pSource);
if (gst_pad_link ( srcpad, audiopad )!= GST_PAD_LINK_OK)
printf("===============link  fail!!!\n");
//gst_element_link ( m_pDecodeBin, m_pAudioConvert );
gst_object_unref(srcpad);
gst_object_unref(audiopad);

GstEvent * redo=gst_event_new_reconfigure(); 
gboolean ret = false;

  ret = gst_element_send_event(GST_ELEMENT(m_pSource), redo);
  if (!ret) 
  printf("send event fail!!!\n");
  
  ret = gst_element_send_event(GST_ELEMENT(m_pDecodeBin), redo);
  if (!ret) 
  printf("send event fail!!!\n");
        gst_element_set_state (m_pDecodeBin, GST_STATE_READY);
        gst_element_set_state (m_pSource, GST_STATE_READY);

  

		return GSTPLAYER_SUCCESS;
	}
	#endif

    int l_iError = GSTPLAYER_SUCCESS;

    ETG_TRACE_USR4 (("SetMediaSource: Creating Generic Pipeline\n"));
    l_iError = CreatePipeline();

    if(l_iError == GSTPLAYER_SUCCESS)
    {
   
            ETG_TRACE_USR4 (("SetMediaSource: Creating FilePlayback Pipeline\n"));
            l_iError = CreateFilePlaybackElements(f_ccMediaSrcPath);
            m_bPlayerInitialized = true;
 
    }
    if(l_iError == GSTPLAYER_SUCCESS)
		ETG_TRACE_USR4 (("!!!!!!!SetMediaSource: Creating FilePlayback fail\n"));
		
    if(m_pSourceName)
    {
        free(m_pSourceName);
        m_pSourceName = NULL;
    }
    m_pSourceName = strdup(f_ccMediaSrcPath);


        m_bPlayerInitialized = true;


    ETG_TRACE_USR4 (("SetMediaSource: Leaving\n"));
	m_goteos=0;
	
	if(m_bPlayerInitialized) 
	{
		//gst_element_set_state(m_pPipeline, GST_STATE_PAUSED);
  GstPad *audiopad;

 
    gst_element_set_state (m_pSource, GST_STATE_NULL);
    gst_element_link ( m_pSource, m_pDecodeBin);
	//gst_object_unref(m_pSource);
//m_pSource = gst_element_factory_make("filesrc", "source");
  g_object_set (G_OBJECT (m_pSource), "location", f_ccMediaSrcPath, NULL);
  /*
                gst_bin_add_many(GST_BIN (m_pPipeline),
                                 m_pSource,
                                 m_pDecodeBin,
                                 (const char*)NULL);	
                                 * */			
//gst_element_link ( m_pSource, m_pDecodeBin);
    gst_element_set_state (m_pSource, GST_STATE_PLAYING);

//audiopad = gst_element_get_static_pad (m_pAudioConvert, "sink");
//gst_pad_activate_mode(audiopad, GST_PAD_MODE_PUSH, true);
//g_object_unref (audiopad);
		return GSTPLAYER_SUCCESS;
	}
    return l_iError;
}

void PlayerInstance::NewPlaySlot( char * f_ccFileToplay , int f_uiPlaypointPosition, int f_iPlaypointFormat )
{
    ETG_TRACE_USR4 (("[SLOT  ] PlayerInstance::NewPlaySlot                          \n"));

    bool l_bSendErrorStateToObserver = 
    !SetStateToPause(f_ccFileToplay,f_uiPlaypointPosition,f_iPlaypointFormat);

    if(!l_bSendErrorStateToObserver)
    {
        //Disintegrate Hotfix #0396 --         m_gstPipelineStateSet = GST_STATE_PLAYING;
        GstStateChangeReturn l_gstStateChange = gst_element_set_state(m_pPipeline, GST_STATE_PLAYING);
        if(GST_STATE_CHANGE_FAILURE == l_gstStateChange)
        {
            ETG_TRACE_ERR (("NewPlaySlot: [ERROR] Setting Pipeline to playing state Failed\n"));
            l_bSendErrorStateToObserver = true;
        }
        else
        {
            ETG_TRACE_USR4 (("NewPlaySlot: Setting Pipeline to playing state Successful\n"));

            GstState l_gstState;
            GstState l_gstPendingState;

            ETG_TRACE_USR4 (("NewPlaySlot: Waiting 5 sec for complete state transition by Getting state\n"));
            l_gstStateChange = gst_element_get_state(m_pPipeline,&l_gstState,&l_gstPendingState,GST_SECOND * 5);

            if(GST_STATE_PLAYING == l_gstState)
            {
                GstFormat l_gstformat = GST_FORMAT_TIME;
                if ( gst_element_query_duration ((GstElement*)m_pPipeline, l_gstformat, &m_iDuration))
                {
                    m_iDuration = m_iDuration / GST_MSECOND;
                    printf ("NewPlaySlot: Got Total Duration = %lld", (unsigned long long) m_iDuration);

                }
                else
                {
                    printf ("NewPlaySlot: No need to query duration incase of AAC and duration calulated is = %d", (int) m_iDuration);
                }

            }
 
            else if(GST_STATE_NULL == l_gstState )
            {
                //Playback can end for small streams and pipeline may reach NULL state.
                //Do nothing in this case as FINISHED state will be send to the observer
                ETG_TRACE_USR4 (("wrong state\n"));

            }
        }
    }
    if(l_bSendErrorStateToObserver)
    {
        ETG_TRACE_ERR (("PlaySlot: [ERROR] Moving Pipeline to Playing state failed \n"));
    }

    ETG_TRACE_USR4 (("NewPlaySlot: Leaving\n"));
}

/* void PlaySlot(const QString f_ccFileToplay)
 * Brief: This function is used for play operation using Phonon
 *
 * Params: const QString f_ccFileToplay {Passes the file to be played}
 * Return: None
 *
 */
void PlayerInstance::PlaySlot (  char * f_ccFileToplay )
{

    ETG_TRACE_USR4 (("PlaySlot: Inside\n"));

    bool l_bSendErrorStateToObserver = false;

    if(f_ccFileToplay != NULL)
    {
        //check if file exists or not
        if (CheckIfFileExists (f_ccFileToplay ))
        {
            char *l_pSourcePath = f_ccFileToplay;
            ETG_TRACE_USR4 (("PlaySlot: Got SourcePath = %s ", l_pSourcePath));

            int l_iError = SetMediaSource(l_pSourcePath);

            if(l_iError == GSTPLAYER_SUCCESS)
            {
                GstStateChangeReturn l_gstStateChange = GST_STATE_CHANGE_SUCCESS;

                if(m_pPipeline && (m_bPlayerInitialized == true))
                {
                    m_bAudioStreamExist = false;
                    m_bVideoStreamExist = false;
                    //m_pAudioPad         = NULL;
                    m_pVideoPad         = NULL;
                    m_bfirstTagInfo     = FALSE;
                    m_iDuration         = 0;


                    ETG_TRACE_USR4 (("PlaySlot: Setting pipeline to Playing state\n"));
                    //Disintegrate Hotfix #0396 --                     m_gstPipelineStateSet = GST_STATE_PLAYING;
                    l_gstStateChange = gst_element_set_state(m_pPipeline, GST_STATE_PLAYING);
                    if(l_gstStateChange == GST_STATE_CHANGE_FAILURE)
                    {
                        ETG_TRACE_ERR (("PlaySlot: [ERROR] Setting Pipeline to playing state Failed\n"));
                        l_bSendErrorStateToObserver = true;
                    }
                    else
                    {
                        ETG_TRACE_USR4 (("PlaySlot:Setting Pipeline to playing state Successful\n"));

                        GstState l_gstState;
                        GstState l_gstPendingState;

                        ETG_TRACE_USR4 (("PlaySlot: Waiting 10 sec for complete state transition by Getting state\n"));
                        l_gstStateChange = gst_element_get_state(m_pPipeline,
                                                                 &l_gstState,
                                                                 &l_gstPendingState,
                                                                 GST_SECOND * 5);

                        if(l_gstState == GST_STATE_PLAYING)
                        {
                            GstFormat l_gstformat = GST_FORMAT_TIME;
                            if ( gst_element_query_duration ((GstElement*)m_pPipeline, l_gstformat, &m_iDuration))
                            {
                                m_iDuration = m_iDuration / GST_MSECOND;
                                printf ("PlaySlot: Got Total Duration = %lld", (unsigned long long) m_iDuration);
                            }
                            else
                            {
                                printf ("PlaySlot: No need to query duration incase of AAC and already duration calulated = %d", (int) m_iDuration);
                            }


                        }
                        else if(GST_STATE_NULL == l_gstState )
                        {
                            //Playback can end for small streams and pipeline may reach NULL state.
                            //Do nothing in this case as FINISHED state will be send to the observer
                        }

                    }
                    if(true == l_bSendErrorStateToObserver)
                    {
                        ETG_TRACE_ERR (("PlaySlot: [ERROR] Moving Pipeline to Playing state failed \n"));


                    }
                }
            }
        }
        else
        {
            ETG_TRACE_ERR (("PlaySlot: [ERROR] File doesn't exists = %s", f_ccFileToplay));



        }
    }
    else
    {
        ETG_TRACE_ERR (("PlaySlot: [ERROR] NULL Parameter\n"));
    }

    ETG_TRACE_USR4 (("PlaySlot: Leaving\n"));
}

void PlayerInstance::ParseError(GstMessage *f_pMsg, GError *f_pError, void *f_pUserData)
{
    PlayerInstance *l_pPlayerInstance = (PlayerInstance *)f_pUserData;

    LOG2("ParseError: Parsing Error");
    if (f_pError->domain == GST_RESOURCE_ERROR)
    {
        ETG_TRACE_USR4(("ParseError: Resource Error\n"));
        if (f_pError->code == GST_RESOURCE_ERROR_READ)
        {
            ETG_TRACE_USR4 (("ParseError: GST_RESOURCE_ERROR_READ\n"));
        }
        else if (f_pError->code == GST_RESOURCE_ERROR_NOT_FOUND)
        {
            ETG_TRACE_USR4(("ParseError: Resource Not Found\n"));
        }
        else if (f_pError->code == GST_RESOURCE_ERROR_OPEN_READ)
        {
            ETG_TRACE_USR4(("ParseError: Open Failed\n"));
        }
        else if (f_pError->code == GST_RESOURCE_ERROR_BUSY)
        {
            ETG_TRACE_USR4(("ParseError: Resource Busy\n"));
        }
        else
        {
            ETG_TRACE_USR4(("ParseError: Unknown Error\n"));
        }
    }
    else if (f_pError->domain == GST_STREAM_ERROR)
    {
        ETG_TRACE_USR4(("ParseError: Stream Error\n"));

    }
    else
    {
        ETG_TRACE_USR4(("ParseError: Unknown Error\n"));
    }
}

gboolean PlayerInstance::MessageLoop(GstBus *f_pBus, GstMessage *f_pMsg, gpointer f_pUserData)
{
    PlayerInstance *l_pPlayerInstance = (PlayerInstance *)f_pUserData;
    static bool l_bFF_ErrorStatus = false;

    (void)f_pBus;
    if(NULL == l_pPlayerInstance || NULL == f_pMsg )
    {
        ETG_TRACE_USR4(("MessageLoop: l_pPlayerInstance or GstMessage is NULL. So doing nothing\n"));
        return l_bFF_ErrorStatus;
    }
    switch (GST_MESSAGE_TYPE (f_pMsg))
    {
		case GST_MESSAGE_DURATION:
		{
			GstFormat l_gstformat = GST_FORMAT_TIME;
			ETG_TRACE_USR4(("MessageLoop: Got Duration Message\n"));

			if (gst_element_query_duration (GST_ELEMENT(l_pPlayerInstance->m_pPipeline), l_gstformat, &l_pPlayerInstance->m_iDuration))
			{
				LOG2("MessageLoop: Got Total Duration:");
				l_pPlayerInstance->m_iDuration = l_pPlayerInstance->m_iDuration / GST_MSECOND;
				printf("m_iDuration===========%d\n", l_pPlayerInstance->m_iDuration);
			}
			else
			{
				gst_message_parse_duration (f_pMsg, NULL, &l_pPlayerInstance->m_iDuration);
				if (GST_CLOCK_TIME_NONE != l_pPlayerInstance->m_iDuration)
				{
					l_pPlayerInstance->m_iDuration = l_pPlayerInstance->m_iDuration / GST_MSECOND;
				}
				else
				{
					ETG_TRACE_USR4 (("MessageLoop: Query duration fail\n"));
				}
			}
			break;
		}
		case GST_MESSAGE_EOS:
		{
			printf("MessageLoop: Got EOS\n\n");
			l_pPlayerInstance->m_goteos=1;
			break;
		}
		case GST_MESSAGE_STATE_CHANGED :
		{
			ETG_TRACE_USR2(("MessageLoop: Got State Change\n"));

			GstState l_gstOldState;
			GstState l_gstNewState;
			GstState l_gstPendingState;
			gst_message_parse_state_changed (f_pMsg, &l_gstOldState,
											 &l_gstNewState, &l_gstPendingState);

			if (l_gstNewState == l_gstPendingState)
			{
				ETG_TRACE_USR2(("MessageLoop: New state is same as Pending state\n"));
				return true;
			}
			else
			{
				ETG_TRACE_USR4 (("MessageLoop: New state is not same as Pending state\n"));
			}

			switch (l_gstNewState)
			{

			case GST_STATE_PLAYING :
			{
				ETG_TRACE_USR2(("MessageLoop: Pipeline in Playing state\n"));
				break;
			}

			case GST_STATE_NULL:
			{
				ETG_TRACE_USR4(("MessageLoop: Pipeline in NULL state\n"));
				break;
			}

			case GST_STATE_PAUSED :
			{
				ETG_TRACE_USR4(("MessageLoop: Pipeline in Paused state\n"));
				break;
			}

			case GST_STATE_READY :
			{
				
				ETG_TRACE_USR4(("MessageLoop: Pipeline in NULL state\n"));
				break;
			}

	
			}
			break;
		}
		case GST_MESSAGE_ERROR:
		{
			gchar *l_pDebug = NULL;
			GError *l_pError = NULL;

			LOG2("MessageLoop: Got Error Message");
			ETG_TRACE_USR4 (("MessageLoop: Got Error Message\n"));

			gst_message_parse_error (f_pMsg, &l_pError, &l_pDebug);
			if(l_pError)
			{
				LOG2("MessageLoop: Got Error");
				l_pPlayerInstance->m_pMessage = gst_error_get_message (l_pError->domain, l_pError->code);
				ParseError(f_pMsg, l_pError, l_pPlayerInstance);
			}
			break;
		}

		default:
		{
			break;
		}
    }

    return true;
}

bool PlayerInstance::SetStateToPause( char* f_ccFileToPause , int f_uiPausePointPosition, int f_iPausepointFormat)
{
    ETG_TRACE_USR4 (("SetStateToPause: Inside\n"));

    bool l_bSendErrorStateToObserver = false;
    bool hasPausedSuccessful = false;

    if (f_ccFileToPause != NULL)
    {
        //check if file exists or not
        if (CheckIfFileExists (f_ccFileToPause ))
        {
            char *l_pSourcePath = f_ccFileToPause;

            printf ("SetStateToPause: Got SourcePath = %s ", l_pSourcePath);

            int l_iError = SetMediaSource(l_pSourcePath);

            if(l_iError == GSTPLAYER_SUCCESS)
            {
                if(m_pPipeline && m_bPlayerInitialized)
                {

                    ETG_TRACE_USR4 (("SetStateToPause: Setting pipeline to Paused state\n"));
                    if(f_uiPausePointPosition != 0)
                    {
                        //Disintegrate Hotfix #0396 --                         m_gstPipelineStateSet = GST_STATE_PAUSED;
                        GstStateChangeReturn l_gstStateChange = gst_element_set_state(m_pPipeline, GST_STATE_PAUSED);
                        if(GST_STATE_CHANGE_FAILURE == l_gstStateChange)
                        {
                            ETG_TRACE_ERR (("SetStateToPause: [ERROR] Setting Pipeline to paused state Failed\n"));
                            l_bSendErrorStateToObserver = true;
                        }
                        else
                        {
                            GstState l_gstState;
                            GstState l_gstPendingState;
                            ETG_TRACE_USR4 (("SetStateToPause: Pipeline changing state asynchronously\n"));
                            ETG_TRACE_USR4 (("SetStateToPause: Waiting infinitely for complete state transition by Getting state\n"));
                            l_gstStateChange = gst_element_get_state(m_pPipeline,
                                                                     &l_gstState,
                                                                     &l_gstPendingState,
                                                                     GST_SECOND * 5);
                            if(GST_STATE_CHANGE_FAILURE != l_gstStateChange
                                    &&
                                    GST_STATE_PAUSED == l_gstState)
                            {
                                hasPausedSuccessful = true;

                                GstFormat l_gstformat = GST_FORMAT_TIME;
                                if (gst_element_query_duration (GST_ELEMENT(m_pPipeline), l_gstformat, &m_iDuration))
                                {
                                    m_iDuration = m_iDuration / GST_MSECOND;
                                    printf ("SetStateToPause: Got Total Duration = %lld", (unsigned long long)m_iDuration);

                                }
                                else
                                {
                                    printf ("SetStateToPause: No need to query duration incase of AAC and duration calulated is = %d", m_iDuration);
                                }


                                ETG_TRACE_USR4 (("SetStateToPause: Setting Pipeline to paused state Successful\n"));


                            }
     
                        }
                    }
                    else
                    {
                        //Since pipeline has been created and its in NO error state
                        hasPausedSuccessful = true;
                    }

                    if(l_bSendErrorStateToObserver)

                    {
                        ETG_TRACE_ERR (("SetStateToPause: [ERROR] Moving Pipeline to Playing state failed \n"));


                    }
                }
            }
        }
        else
        {
            printf (("SetStateToPause: [ERROR] File doesn't exists = %s", f_ccFileToPause));

        }
    }
    else
    {
        ETG_TRACE_ERR (("SetStateToPause: [ERROR] NULL Parameter\n"));
    }

    ETG_TRACE_USR4 (("SetStateToPause: Leaving with hasPausedSuccessful , \n"));
    return hasPausedSuccessful;
}


void getlimit()
{
	  struct rlimit limit;

  /* Get max number of files. */
  if (getrlimit(RLIMIT_NOFILE, &limit) != 0) {
    printf("getrlimit() failed with errno=%d\n", errno);
    return ;
  }

  printf("The soft limit is %d\n", limit.rlim_cur);
  printf("The hard limit is %d\n", limit.rlim_max);

}


void setlimit()
{
	struct rlimit limit;
	limit.rlim_cur = 100;
	limit.rlim_max = limit.rlim_cur;

	printf("set soft limit  %d\n", limit.rlim_cur);
  	printf("set hard limit  %d\n", limit.rlim_max);

  if (setrlimit(RLIMIT_NOFILE, &limit) != 0)
  {
    printf("setrlimit() failed with errno=%d\n", errno);
    return ;
  }

getlimit();

}
void g_main_loop_thread_fun(void *data)
{

	#define BASEPATH "/root"
	int i=1;
	char path[128];
printf("g_main_loop_thread_fun\n");
setlimit();
PlayerInstance *l_pInstance= new PlayerInstance(path);;
	for (i=1;i<1000;i++) 
	{
		
		memset(path, 0, 128);
		if(data)
			sprintf(path, "%s/%05d_mp3_Title_4sec.mp3", (char*)data, i );
			else
		sprintf(path, "%s/%05d_mp3_Title_4sec.mp3", BASEPATH, i );
		printf("\n\n\n=====================================\n");
		printf("play %s\n", path);

		l_pInstance->NewPlaySlot (path, 1, 0);
		
		for(;;) {
			sleep(2);
			if(l_pInstance->m_goteos==1) {
				printf("play %s done\n", path);
				//l_pInstance->SetPipelineToStoppedState();

				//delete(l_pInstance);
				//l_pInstance=NULL;
				break;
			}
				
		}
	}
}

int main(int argc, char *argv[])
{
	char *fn="/root/1.mp3";
	#define BASEPATH "/root"
	int i=1;
	char path[128];
	if(!g_thread_supported())
		g_thread_init(NULL);
	gst_init(NULL, NULL);
	g_main_loop = g_main_loop_new(NULL, TRUE);
	g_thread_try_new("thd",(GThreadFunc)g_main_loop_thread_fun, argv[1], NULL);

	g_main_loop_run(g_main_loop);
	return 0;
}

#if 0
		for(;;) {
			sleep(2);
			if(l_pInstance->m_goteos==1) {
				printf("play %s done\n", path);
				l_pInstance->SetPipelineToStoppedState();

				delete(l_pInstance);
				l_pInstance=NULL;
				break;
			}
				
		}
#endif
